/**************************************************************************
*                                                                         *
*   EthernetMIDI - multiplatform MIDI over Ethernet / LAN                 *
*                                                                         *
*   Copyright (C) 2005 by Benno Senoner , Italy                           *
*   http://www.linuxsampler.org/ethernetmidi                              *
*   EMail: sbenno@gardena.net                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the Free Software           *
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
*   MA  02111-1307  USA                                                   *
***************************************************************************/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include "mainwindowbase.h"

#include <qpainter.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qtimer.h>
#include <qdatetime.h>
#include <qstring.h>

#include "midiio.h"
#include "socketio.h"

#include "midithread.h"

class MidiThread;

class MainWindow : public MainWindowBase {

public:
        MainWindow(QWidget* parent = 0, const char* name = 0, WFlags fl = 0);
        ~MainWindow();

        void logMessage(const QString &str, int mode);


        int InputPortIndex;
        int OutputPortIndex;


        MidiIO *midiio;
        SocketIO *socketio;

        int MidiInActivity;
        int MidiOutActivity;

        bool MidiEnabled;

// FIXME: remove testvalue. only for testing
int testvalue; 


public slots:
  void startstop_buttongroup_clicked(int id);
  void midiin_listbox_highlighted(int id);
  void midiout_listbox_highlighted(int id);
  void timer_slot(void);

private:

  MidiThread *midithread;

};
#endif

