/**************************************************************************
*                                                                         *
*   EthernetMIDI - multiplatform MIDI over Ethernet / LAN                 *
*                                                                         *
*   Copyright (C) 2005 by Benno Senoner , Italy                           *
*   http://www.linuxsampler.org/ethernetmidi                              *
*   EMail: sbenno@gardena.net                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the Free Software           *
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
*   MA  02111-1307  USA                                                   *
***************************************************************************/

#ifndef SOCKETIO_H
#define SOCKETIO_H


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <winsock2.h>
#include <ws2tcpip.h>


class SocketIO {

public:

  SocketIO();
  ~SocketIO();

  int init(void);
  int openTCPSocket(const char *hostname, unsigned short port);
  int send(void *buffer, int len, int flags);
  int recv(void *buffer, int len, int flags);
  int closeTCPSocket();
  int closeUDPSocket();

  int udpSend(void *buffer, int len);
  int udpRecv(void *buffer, int len);

  int openUdpSocket(const char *hostname, unsigned short port, unsigned short local_port);


private:

  WSADATA wsaData;
  SOCKET m_socket;
  SOCKET udp_socket;

  sockaddr_in RemoteAddr;
  sockaddr_in LocalAddr;
  sockaddr_in SenderAddr; // used for udpRecv()
};

#endif
